
> module Main where
> import Communication
> import SimplerRobotG
> import System(getArgs)
> import MemoryBot
> import List

> main = do a <- getArgs
>           case length a of
>              2 -> runProgram (("noLoop"):a)
>              3 -> runProgram a
>              _ -> error "usage: robot [algo] host port"

> runProgram [rn, host, port] = case (find (\x -> x==rn) ["noLoop"]) of
>		       Nothing -> runProgramG [rn, host, port]
>		       (Just _) -> runProgramM [rn, host, port]

> runProgramM [rn, host, port] = do run (robot rn) host (read port)
>     where robot "noLoop" = noLoopBot

> runProgramG [rn, host, port] = do run (robot rn) host (read port)
>     where robot "lazy" = lazyBot
>           robot "hunter" = hunterBot
>	    robot "prio" = priorityBot
>	    robot "avoid" = avoidBot

