> module RobotAlgos where
> import GameState
> import Map
> import Robot

Returns the direction r1 can push r2.

> canPush :: GameState -> Int -> Int -> Maybe Direction
> canPush gs id1 id2 = 
>    case (dx,dy) of
>       (0,n) | (n>0) ->
>	  if (all (\p-> case (robotAt gs p) of
>	                      Just _ -> True
>		              Nothing -> False)
>                 [(x1,y) | y<-[y1+1,y1+2..y2-1]])
>	  then Just North else Nothing
>	      | (n<0) ->
>         if (all (\p-> case (robotAt gs p) of
>	                      Just _ -> True
>                             Nothing -> False)
>                 [(x1,y) | y<-[y1-1,y1-2..y2+1]])
>	  then Just South else Nothing
>       (n,0) | (n>0) ->
>         if (all (\p-> case (robotAt gs p) of
>	                      Just _ -> True
>                             Nothing -> False)
>                 [(x,y1) | x<-[x1+1,x1+2..x2-1]])
>	  then Just East else Nothing
>             |(n<0)->
>         if (all (\p-> case (robotAt gs p) of
>	                      Just _ -> True
>                             Nothing -> False)
>                 [(x,y1) | x<-[x1-1,y1-2..y2+1]])
>         then Just West else Nothing
>       (_,_) -> Nothing
>  where (x1,y1)=(robotPos (getRobotData gs id1))
>        (x2,y2)=(robotPos (getRobotData gs id2))
>        (dx,dy)=(x2-x1,y2-y1)
>	 rd = getRobotDatas gs

> canKill :: GameState -> Int -> Int -> Maybe Direction
> canKill gs id1 id2 =
>     do x <- (canPush gs id1 id2)
>        if (floorAt m (move x pr1))==Water then Just x else Nothing
>  where pr1=(robotPos (getRobotData gs id2))
>        m = getMap gs

> whoCanIFoo :: (GameState -> Int -> Int -> Maybe Direction) 
>	  -> GameState -> Int -> [(RobotData,Direction)]
> whoCanIFoo canFoo gs id = filtrMap rl
>  where  rl = map (\r -> (r,(canFoo gs id (robotId r)))) rd
>         filtrMap [] = []
>	  filtrMap ((r,Just d):rs) = ((r,d):(filtrMap rs))
>	  filtrMap ((r,Nothing):rs) = filtrMap rs
>         rd = getRobotDatas gs

> whoCanIPush = whoCanIFoo canPush
> whoCanIKill = whoCanIFoo canKill

> whoCanFooMe ::  (GameState -> Int -> Int -> Maybe Direction)
>         -> GameState -> Int -> [RobotData]
> whoCanFooMe canFoo gs id = 
>     [r | r<-(getRobotDatas gs), case (canFoo gs (robotId r) id) of 
>      Just _ -> True
>      Nothing -> False]


> whoCanPushMe = whoCanFooMe canPush
> whoCanKillMe = whoCanFooMe canKill

Bumped analysis

Returns list of (a,p) for a being bumped by someone at p.
Want gameState before execution of serverEvents as parameter

> bumpAnalysis1 :: GameState -> [ServerEvent] -> [(Int,Position)]
> bumpAnalysis1 gs es = rule1 gs es []
>  where
>  rule1 gs (e@(RobotMoved i _):es) moved = 
>      let gs' = updateGameState gs e
>          scene = (robotPos (getRobotData gs i))
>      in if (any (\j -> i==j) moved) then ((i,scene):(rule1 gs' es moved))
>         else (rule1 gs' es (i:moved))
>  rule1 gs (_:es) moved = rule1 gs es moved

test code

> gs1 = (GameState exampleMap [] 
>       [(RobotData 1 (1,2)), 
>        (RobotData 2 (2,2)), 
>        (RobotData 3 (2,1)),
>        (RobotData 4 (2,3)),
>        (RobotData 5 (3,2)),
>        (RobotData 6 (4,4))] 0 0 0 (findBases exampleMap) [])
