> module SimplerRobot where
> import Map
> import List
> import Paths
> import Robot
> import Array

a represents gamestate
b is the type to compare

> data (Ord b) => Restriction a b = 
>     Restriction (a -> AllMultiPaths -> Maybe Direction -> (b,Int))

c is a reason for the suggestion

> data (Ord b) => Suggestion a b c = 
>     Suggestion (a -> AllMultiPaths  -> [(RobotCommand,b,c)])

> addCost a (Move b c d) = (Move (a+b) c d)
> addCost _ b = b

> simplerRobotChoice :: 
>    (Ord b) => [Suggestion a b c] -> [Restriction a b] -> AllMultiPaths -> Int -> a -> RobotCommand
> simplerRobotChoice moves notmoves paths id state =
>     if null sugg then Pick 1 id [] 
>     else addCost (moveAway-(dontMove best)) best
>  where
>     sugg = (mergeSortedListsBy cmp 
>      (map sortSugg moves))
>     sortSugg (Suggestion s) = (sortBy revcmp (s state paths))
>     cmp (_,x,_) (_,y,_) = (compare x y)
>     revcmp x y = (cmp y x)
>     filterSugg = (filter (\p -> 
>		    (any (\r -> (checkRestrict r p)) notmoves)) sugg)
>     checkRestrict (Restriction r) (a,b,_) = (fst (r state paths (moveToDir a))) < b
>     (best,valBest,reason) = if null filterSugg then head sugg else head filterSugg
>     moveAway = if null notmoves then 0 else
>	 maximum [(snd (r state paths Nothing)) | (Restriction r)<-notmoves]
>     dontMove (Move _ _ d) = if null notmoves then 0 else
>	 maximum [(snd (r state paths (Just d))) | (Restriction r)<-notmoves]
>     dontMove _ = 0


> moveToDir (Move _ _ d) = Just d
> moveToDir _ = Nothing


> mergeSortedListsBy _ [] = []
> mergeSortedListsBy _ (a:[]) = a
> mergeSortedListsBy cmp ([]:l) = mergeSortedListsBy cmp l
> mergeSortedListsBy cmp (a@(h:t):l) = let (rh, rl) = better h l in 
>      if (cmp h rh)==LT then (rh:(mergeSortedListsBy cmp (a:rl)))
>			      else (h:(mergeSortedListsBy cmp (t:l)))
>  where
>   better h [] = (h,[])
>   better h ([]:b) = better h b
>   better h (l@(hd:tl):b) | (cmp h hd)==LT = let (rh,rl) = (better hd b) in
>					  if (cmp hd rh)==LT then (rh, (l:rl))
>				          else (hd, (tl:rl))
>		           | otherwise = let (rh,rl) = (better h b) in (rh,(l:rl))

> doSRobot update1 update2 choice state events pkgs = (state'', decision)
>  where
>   state' = update1 state events pkgs
>   state'' = update2 state' decision
>   decision = choice state'