> module StdSugg where
> import GameState
> import Robot
> import Map
> import Paths
> import Array
> import List

HB = Home Base

> data Reason = PD PackageData | RD RobotData | HB Position deriving (Eq, Show)

> optimalDeliver paths 
>    p1@(PackageData _ (Just d1) _ _) 
>    p2@(PackageData _ (Just d2) _ _) =
>      case (distanceToM paths d1) of
>	    Nothing -> LT
>	    (Just len1) -> case (distanceToM paths d2) of
>		           Nothing -> GT
>		           (Just len2) -> if len1 < len2 then GT else LT
> optimalDeliver _ (PackageData _ Nothing _ _) _ = LT
> optimalDeliver _ _ (PackageData _ Nothing _ _) = GT

> optimalRetrieve paths
>    p1@(PackageData _ _ _ (PackageOnFloor d1))
>    p2@(PackageData _ _ _ (PackageOnFloor d2)) =
>      case (distanceToM paths d1) of
>          Nothing -> LT
>          (Just len1) -> case (distanceToM paths d2) of
>                        Nothing -> GT
>			 (Just len2) -> if len1 < len2 then GT else LT
> optimalRetrieve _ (PackageData _ _ _ (PackageOnFloor _)) _ = GT
> optimalRetrieve _ _ (PackageData _ _ _ (PackageOnFloor _)) = LT
> optimalRetrieve _ _ _ = GT

> optimalBases paths d1 d2 =
>      case (distanceToM paths d1) of
>          Nothing -> LT
>          (Just len1) -> case (distanceToM paths d2) of
>                        Nothing -> GT
>                        (Just len2) -> if len1 < len2 then GT else LT

> optimalBot paths (RobotData _ d1) (RobotData _ d2) =
>      case (distanceToM paths d1) of
>          Nothing -> LT
>          (Just len1) -> case (distanceToM paths d2) of
>                        Nothing -> GT
>                        (Just len2) -> if len1 < len2 then GT else LT

Doesn't this crash when the pattern isn't matched!
Oh that doesn't happen becaue any package we could pick up we know everything about.

> optimalPickup paths (PackageData _ (Just d1) (Just w1) _) (PackageData _ (Just d2) (Just w2) _) =
>     compare (distanceToM paths d1, -w1) (distanceToM paths d2, -w2)

> bestPickup paths packages capacity = best (sortBy (optimalPickup paths) packages) capacity
>     where best [] _ = []
>           best (x:xs) c = if (wt x) > c then best xs c
>                           else x:best xs (c-(wt x))
>           wt (PackageData _ _ (Just w) _) = w

> accessible paths pos = case (distanceToM paths pos) of
>                                            Nothing -> False
>                                            (Just _) -> True

> huntableBots g paths =
>     (filter
>             (\r -> (any pkgFilter
>               (map (getPackageData g) (packagesWith g (robotId r)))))
>             possibleBot)
>  where
>     ps = getPackageDatas g
>     rs = getRobotDatas g
>     cap = availableCapacity g
>     pkgFilter (PackageData _ _ Nothing _) = True
>     pkgFilter (PackageData _ _ (Just w) _) = w <= cap     
>     notMe = (filter (\r -> (robotId r)/=(getId g)) rs)
>     possibleBot = (filter (\r -> accessible paths (robotPos r)) notMe)

> huntSugg cost g allPaths =
>     foldl (++) [] (map values (huntableBots g paths))
>  where
>   paths = (allPaths!(myPosition g))
>   id = (getId g)
>   values bot = let (MultiRange dist dirs) = (paths!(robotPos bot)) in
>			       [(Move cost id dir, dist, RD bot)|dir<-dirs]

> pickUpSugg cost g allPaths = if null bestPackages then [] else [cmd]
>  where
>   myPos = (myPosition g)
>   paths = (allPaths!myPos)
>   paksHere = packagesAt g myPos
>   deliverable (PackageData _ (Just l) _ _) = accessible paths l
>   bestPackages = map packageId $
>	   bestPickup paths (filter deliverable (map (getPackageData g) paksHere)) cap
>   cap = availableCapacity g
>   cmd = (Pick cost id bestPackages)
>   id = (getId g)

> dropOffSugg cost g allPaths = if null paksForHere then [] else [cmd]
>  where
>   pk = getPackageDatas
>   myPos = myPosition g
>   myPak = myPackages g
>   paksForHere = filter 
>	  (\pk-> (packageDest (getPackageData g pk))==(Just myPos)) 
>         myPak
>   cmd = (Drop cost id paksForHere)
>   id = (getId g)

> goToBaseSugg cost g allPaths = foldl (++) [] $ map value (filter (accessible paths) bases)
>  where
>   bases = getBases g 
>   paths = (allPaths!(myPosition g))
>   id = (getId g)
>   value base = let (MultiRange dist dirs) = paths!base in
>				[(Move cost id dir, dist, HB base)|dir<-dirs]

> fetchSugg cost g allPaths = foldl (++) [] $ map value ups
>  where
>   ps = getPackageDatas g
>   paths = (allPaths!myPos)
>   myPos = myPosition g
>   cap = availableCapacity g
>   ups = filter usefulPackage ps
>   usefulPackage (PackageData _ _ (Just w) _) | w>cap = False
>   usefulPackage (PackageData _ _ _ (PackageInRobot _)) = False
>   usefulPackage (PackageData _ _ _ (PackageOnFloor l)) = accessible paths l
>   usefulPackage _ = True
>   value pd@(PackageData _ _ _ (PackageOnFloor l)) = 
>      let (MultiRange dist dirs) = (paths!l) in
>		      [(Move cost id dir, dist, PD pd)|dir<-dirs]
>   id = (getId g)

> deliverSugg cost g allPaths = foldl (++) [] $ map value myPaks
>  where
>   myPaks = map (getPackageData g) (myPackages g)
>   paths = (allPaths!(myPosition g))
>   value pd@(PackageData _ (Just l) _ _) =
>      let (MultiRange dist dirs) = (paths!l) in
>		      [(Move cost id dir, dist, PD pd)|dir<-dirs]
>   id = (getId g)